const bodyParser = (req, body, done) => {
	try {
		const newBody = { ...JSON.parse(body.toString()) };

		const timezone = req.headers.timezone || req.headers.TIMEZONE;
		newBody.timezone = timezone ? parseInt(timezone.toString()) : 0;

		done(null, newBody);
	} catch (error) {
		error.statusCode = 400;
		done(error, undefined);
	}
};

module.exports = bodyParser;
