const ErrorCodes = require("../objects/errorCodes");
const ErrorResult = require("../objects/errorResult");

const errorHandler = (logger) => (error, request, reply) => {
	let err = ErrorResult(ErrorCodes.UNKNOWN_ERROR);
	if (reply.statusCode === 429) {
		err = ErrorResult(ErrorCodes.TOO_MANY_REQUEST);
	}

	if (error.name === "ArgumentRequiredError") {
		err = ErrorResult(ErrorCodes.MISSING_PARAMETERS);
	}

	logger.captureException(error);
	console.log(`Error: ${error.message}`);
	reply.code(200);
	reply.send(err);
};

module.exports = errorHandler;
