const Sentry = require("@sentry/node");
const TransactionModel = require("../objects/transaction");

const transactions = [];
class Logger {
	startTransaction(request) {
		const transaction = Sentry.startTransaction({
			op: request.method,
			name: request.url,
		});

		transaction.setData("ip", request.ip);
		transaction.setData("hostName", request.hostname);
		transaction.setData("query", request.query);
		transaction.setData("requestHeaders", request.headers);

		Sentry.configureScope((scope) => {
			scope.setSpan(transaction);
		});

		transactions.push(new TransactionModel(request.id, transaction));
	}

	endTransaction(request, reply, payload) {
		const transaction = transactions.find((x) => x.id === request.id);
		if (transaction) {
			const { item } = transaction;
			item.setData("requestBody", request.body);
			item.setData("responseHeaders", reply.getHeaders());
			item.setData("responseBody", JSON.parse(payload));
			item.finish();
			transactions.splice(transactions.indexOf(transaction), 1);
		}
	}

	captureException(error) {
		Sentry.captureException(error);
	}
}

module.exports = Logger;
