const ErrorCodes = require("../objects/errorCodes");

// eslint-disable-next-line consistent-return
const requestHandler = (logger) => (request, reply, done) => {
	logger.startTransaction(request);

	let error = null;

	try {
		const userToken = request.headers["x-access-token"] || request.headers["X-ACCESS-TOKEN"] || request.headers["X-Access-Token"] || "";
		const isValid = process.env.AUTH_TOKEN.toUpperCase() === userToken.toString().toUpperCase();

		if (!isValid) {
			error = new Error(ErrorCodes.AUTHORIZATION_ERROR);
		}
	} catch (err) {
		error = err;
	}

	done(error);
};

module.exports = requestHandler;
