const TestService = require("../services/testService");
const ScooterDataAccess = require("../data/models/scooter");
const required = require("../decorators/argumentRequired");
// const ErrorResult = require("../objects/errorResult");
// const ErrorCodes = require("../objects/errorCodes");
const rds = require("../data/rds/rds");

const pool = rds.createPool();

const dataAccess = new ScooterDataAccess();
const service = new TestService(dataAccess, rds.query(pool));

const scooter = async (app) => {
	app.post("/list", async (req) => {
		required("code")(req.body);

		const response = await service.list(req.body);
		return response;
	});
};

module.exports = scooter;
