const SuccessResult = require("../objects/successResult");

class ScooterService {
	constructor(dataAccess) {
		this.dataAccess = dataAccess;
	}

	async save(request) {
		const scooterDto = await this.dataAccess.save(request);
		return SuccessResult({ scooter: scooterDto });
	}

	async listAvailables(lat, lon, vehicleType, maxDistance, limit) {
		const condition = {
			vehicle_type: { $in: vehicleType },
			status_id: 1,
			version: { $ne: 0 },
			is_available: true,
		};

		const scooters = await this.dataAccess.geoNear(lat, lon, condition, maxDistance, limit);
		return SuccessResult(scooters);
	}
}

module.exports = ScooterService;
